- Amazon MSK
- Apache Pulsar (in Preview)
- Azure Event Hubs
- Cloud Storage / HTTP
- Confluent Cloud
- Google Cloud Pub/Sub
- Kafka
- Webhook
Sink URI
The sink URI follows the basic format of:| URI Component | Description |
|---|---|
scheme | The type of sink: kafka, gcpubsub, any cloud storage sink, or webhook sink. |
host | The sink’s hostname or IP address. |
port | The sink’s port. |
query\_parameters | The sink’s . |
ALTER CHANGEFEED.
Cockroach Labs recommends enabling Egress Perimeter Controls on CockroachDB Advanced clusters to mitigate the risk of data exfiltration when accessing external resources, such as cloud storage for change data capture or backup and restore operations. See for detail and setup instructions.
Kafka
Kafka sink connection
Example of a Kafka sink URI usingSCRAM-SHA-256 authentication:
OAUTHBEARER authentication:
| URI Parameter | Description |
|---|---|
topic\_name | The topic name to which messages will be sent. See the following section on Topic Naming for detail on how topics are created. |
topic\_prefix | Adds a prefix to all topic names. For example, CREATE CHANGEFEED FOR TABLE foo INTO 'kafka://...?topic\_prefix=bar\_' would emit rows under the topic bar\_foo instead of foo. |
tls\_enabled | If true, enable Transport Layer Security (TLS) on the connection to Kafka. This can be used with a ca\_cert (see below). Default:false |
ca\_cert | The base64-encoded ca\_cert file. Specify ca\_cert for a Kafka sink. Note: To encode your ca.cert, run base64 -w 0 ca.cert. |
client\_cert | The base64-encoded Privacy Enhanced Mail (PEM) certificate. This is used with client\_key. |
client\_key | The base64-encoded private key for the PEM certificate. This is used with client\_cert. Note: Client keys are often encrypted. You will receive an error if you pass an encrypted client key in your changefeed statement. To decrypt the client key, run: openssl rsa -in key.pem -out key.decrypt.pem -passin pass:{PASSWORD}. Once decrypted, be sure to update your changefeed statement to use the new key.decrypt.pem file instead. |
sasl\_client\_id | Client ID for OAuth authentication from a third-party provider. This parameter is only applicable with sasl\_mechanism=OAUTHBEARER. |
sasl\_client\_secret | Client secret for OAuth authentication from a third-party provider. This parameter is only applicable with sasl\_mechanism=OAUTHBEARER. Note: You must base64 encode this value when passing it in as part of a sink URI. |
sasl\_enabled | If true, the authentication protocol can be set to SCRAM or PLAIN using the sasl\_mechanism parameter. You must have tls\_enabled set to true to use SASL. Default:false |
sasl\_grant\_type | Override the default OAuth client credentials grant type for other implementations. This parameter is only applicable with sasl\_mechanism=OAUTHBEARER. |
sasl\_mechanism | Can be set to OAUTHBEARER, SCRAM-SHA-256, SCRAM-SHA-512, or PLAIN. A sasl\_user and sasl\_password are required. Default:PLAIN |
sasl\_scopes | A list of scopes that the OAuth token should have access for. This parameter is only applicable with sasl\_mechanism=OAUTHBEARER. |
sasl\_token\_url | Client token URL for OAuth authentication from a third-party provider. This parameter is only applicable with sasl\_mechanism=OAUTHBEARER. Note: You must URL encode this value before passing in a URI. |
sasl\_user | Your SASL username. |
sasl\_password | Your SASL password |
insecure\_tls\_skip\_verify | If true, disable client-side validation of responses. Note that a CA certificate is still required; this parameter means that the client will not verify the certificate. Warning: Use this query parameter with caution, as it creates MITM vulnerabilities unless combined with another method of authentication. Default:false |
CREATE CHANGEFEED page provides a list of all the available .
Topic naming
By default, a Kafka topic has the same name as the table on which a changefeed was created. If you create a changefeed on multiple tables, the changefeed will write to multiple topics corresponding to those table names. When you runCREATE CHANGEFEED to a Kafka sink, the output will display the job ID as well as the topic name(s) that the changefeed will emit to.
To modify the default topic naming, you can specify a , , or use the . Using the parameter, you can specify an arbitrary topic name and feed all tables into that topic.
You can either manually create a topic in your Kafka cluster before starting the changefeed, or the topic will be automatically created when the changefeed connects to your Kafka cluster.
You must have the Kafka cluster setting
auto.create.topics.enable set to true for automatic topic creation. This will create the topic when the changefeed sends its first message. If you create the consumer before that, you will also need the Kafka consumer configuration allow.auto.create.topics to be set to true.- Legal characters are numbers, letters, and
[._-]. - The maximum character length of a topic name is 249.
- Topics with a period (
.) and underscore (_) can collide on internal Kafka data structures, so you should use either but not both. - Characters not accepted by Kafka will be automatically encoded as unicode characters by CockroachDB.
Kafka sink configuration
You can configure flushing, acknowledgments, compression, and concurrency behavior of changefeeds running to a Kafka sink with the following:- Set the to configure the number of concurrent workers used by changefeeds in the cluster when sending requests to a Kafka sink. When you set
changefeed.sink_io_workers, it will not affect running changefeeds; , setchangefeed.sink_io_workers, and then .changefeed.sink_io_workerswill also affect changefeeds running to Google Cloud Pub/Sub sinks and webhook sinks.
changefeed.sink_io_workers only applies to Kafka sinks created in v24.2.1+, or if the changefeed.new_kafka_sink.enabled cluster setting has been enabled in CockroachDB clusters running v23.2.10+ and v24.1.4+.- The
kafka_sink_configoption allows configuration of a changefeed’s message delivery, Kafka server version, and batching parameters.
Each of the following settings have significant impact on a changefeed’s behavior, such as latency. For example, it is possible to configure batching parameters to be very high, which would negatively impact changefeed latency. As a result it would take a long time to see messages coming through to the sink. Also, large batches may be rejected by the Kafka server unless it’s separately configured to accept a high
max.message.bytes.kafka_sink_config will mean that changefeed messages emit immediately.
The configurable fields are as follows:
| Field | Type | Description | Default |
|---|---|---|---|
"ClientID" | Applies a Kafka client ID per changefeed. Configure quotas within your Kafka configuration that apply to a unique client ID. The ClientID field can only contain the characters A-Za-z0-9.\_-. For more details, refer to ClientID. | "" | |
"Compression" | Sets a compression protocol that the changefeed should use when emitting events. The possible values are: "NONE", "GZIP", "SNAPPY", "LZ4", "ZSTD". | "NONE" | |
"CompressionLevel" | Sets the level of compression. This determines the level of compression ratio versus compression speed, i.e., how much the data size is reduced (better compression) and how quickly the compression process is completed. For the compression protocol ranges, refer to CompressionLevel. Note: If you have the changefeed.new\_kafka\_sink.enabled cluster setting disabled, CompressionLevel will not affect LZ4 compression. SNAPPY does not support CompressionLevel. | Refer to CompressionLevel | |
"Flush"."Bytes" | When the total byte size of all the messages in the batch reaches this amount, it should be flushed. | 0 | |
"Flush"."Frequency" | Duration string | When this amount of time has passed since the first received message in the batch without it flushing, it should be flushed. For more details, refer to Flush. | "0s" |
"Flush"."MaxMessages" | Sets the maximum number of messages the producer can send in a single broker request. Any messages beyond the configured limit will be blocked. Increasing this value allows all messages to be sent in a batch. For more details, refer to Flush. | 1000 | |
"Flush"."Messages" | Configures the number of messages the changefeed should batch before flushing. | 0 | |
"RequiredAcks" | Specifies what a successful write to Kafka is. CockroachDB — this value defines the delivery. The possible values are: ONE, NONE, ALL. For details on each value, refer to RequiredAcks. | "ONE" | |
"Version" | Sets the appropriate Kafka cluster version, which can be used to connect to Kafka versions < v1.0 (kafka\_sink\_config='{"Version": "0.8.2.0"}'). | "1.0.0.0" |
ClientID
Implement a Kafka resource usage limit per changefeed by setting a client ID and Kafka quota. You can set the quota for the client ID in your Kafka server’s configuration:
"ClientID" field with the unique client ID (e.g., kafka_client_ID_1) you have configured in your Kafka server configuration. This will subject the changefeed to the Kafka quota applied to that client ID. We recommend tracking the to monitor the time spent throttling due to changefeed messages exceeding Kafka quotas.
For details on setting quotas to client IDs, refer to the Kafka documentation.
CompressionLevel
The CompressionLevel field allows you to implement a level of compression for your set Compression protocol. CompressionLevel determines the level of the compression ratio versus the compression speed. That is, how much the data is reduced for better compression and how quickly the compression is completed for faster compression. The compression protocols support the following values:
GZIP:-2: Huffman-only compression-1: Default compression0: No compression1to9: From fastest compression to best compression
ZSTD:1: Fastest compression2: Default compression3: Better compression4: Best compression
LZ4: The supported values from fastest compression to best compression:-
0: Fastest compression (Default) -
512 -
1024 -
2048 -
4096 -
8192 -
16384 -
32768 -
65536 -
131072: Best compression If you have thechangefeed.new_kafka_sink.enabledcluster setting disabled,CompressionLevelwill not affectLZ4compression.
-
SNAPPYdoes not support theCompressionLevelfield.
Flush
"Flush"."MaxMessages" and "Flush"."Frequency" are configurable batching parameters depending on latency and throughput needs. For example, if "MaxMessages" is set to 1000 and "Frequency" to 1 second, it will flush to Kafka either after 1 second or after 1000 messages are batched, whichever comes first. It’s important to consider that if there are not many messages, then a "1s" frequency will add 1 second latency. However, if there is a larger influx of messages these will be flushed quicker.
RequiredAcks
The RequiredAcks field defines what a successful write to Kafka is. The possible values are:
"ONE": A write to Kafka is successful once the leader node has committed and acknowledged the write. Note that this has the potential risk of dropped messages; if the leader node acknowledges before replicating to a quorum of other Kafka nodes, but then fails."NONE": No Kafka brokers are required to acknowledge that they have committed the message. This will decrease latency and increase throughput, but comes at the cost of lower consistency."ALL": A quorum must be reached (that is, most Kafka brokers have committed the message) before the leader can acknowledge. This is the highest consistency level. You must also setackstoALLin your server-side Kafka configuration for this to provide high durability delivery.
Kafka sink messages
The following shows the messages for a changefeed emitting to Kafka:Amazon MSK
On CockroachDB self-hosted clusters, you must create instances in the same VPC as the MSK or MSK Serverless cluster in order for the changefeed to authenticate successfully.If you would like to connect a CockroachDB Advanced cluster to an Amazon MSK cluster, contact your Cockroach Labs account team.
Changefeeds can deliver messages to Amazon MSK clusters (Amazon Managed Streaming for Apache Kafka). Amazon MSK cluster types include: MSK and MSK Serverless. Changefeeds support the following authentication methods for these MSK cluster types:
- MSK:
SCRAMorIAM - MSK Serverless:
IAM
kafka:// scheme. The example URIs show the necessary parameters for MSK and MSK Serverless clusters depending on the authentication type:
-
To connect to an MSK cluster using
SCRAMauthentication, you must include the following parameters in the URI:For SCRAM authentication, add your SASL username and password to the URI. -
To connect to an MSK or MSK Serverless cluster using AWS IAM roles, you must include the following parameters in the URI:
For IAM authentication, add the MSK cluster region, IAM role ARN, and session name to the URI.
| URI Parameter | Description |
|---|---|
cluster\_endpoint | The endpoint listed for your Amazon MSK cluster in the AWS Console. For example, boot-a1test.c3.kafka-serverless.us-east-2.amazonaws.com:9098. |
sasl\_aws\_iam\_role\_arn | The ARN for the IAM role that has the permissions to create a topic and send data to the topic. |
sasl\_aws\_iam\_session\_name | The user-specified string that identifies the session in AWS. |
sasl\_aws\_region | The region of the Amazon MSK cluster. |
sasl\_enabled | Enable SASL authentication. Set this to true. |
sasl\_mechanism | Set to AWS\_MSK\_IAM, SCRAM-SHA-512, or SCRAM-SHA-256. |
sasl\_password | Your SASL password. |
sasl\_user | Your SASL username. |
tls\_enabled | Enable Transport Layer Security (TLS) on the connection to Amazon MSK clusters. Set this to true. |
Confluent Cloud
Changefeeds can deliver messages to Kafka clusters hosted on Confluent Cloud. A Confluent Cloud sink connection URI must include the following:api_key and api_secret are the required parameters for the Confluent Cloud sink connection URI.
| URI Parameter | Description |
|---|---|
bootstrap server | The bootstrap server listed for your Kafka cluster in the Confluent Cloud console. |
api\_key | The API key created for the cluster in Confluent Cloud. |
api\_secret | The API key’s secret generated in Confluent Cloud. Note: This must be URL-encoded before passing into the connection string. |
topic_name and topic_prefix. Confluent Cloud sinks also support the standard Kafka and the Kafka sink configuration option.
For a Confluent Cloud setup example, refer to the page.
The following parameters are also needed, but are set by default in CockroachDB:
tls_enabled=truesasl_enabled=truesasl_handshake=truesasl_mechanism=PLAIN
Google Cloud Pub/Sub
Changefeeds can deliver messages to a Google Cloud Pub/Sub sink, which is integrated with Google Cloud Platform.Since CockroachDB v23.2, the
changefeed.new_pubsub_sink_enabled cluster setting is enabled by default, which provides improved throughput. Without this cluster setting enabled, changefeeds emit JSON-encoded events with the top-level message fields all lowercase. With changefeed.new_pubsub_sink_enabled, the top-level fields are capitalized. For more details, refer to the Pub/Sub sink messages section.| URI Parameter | Description |
|---|---|
project name | The Google Cloud Project name. |
region | (Optional) The single region to which all output will be sent. If you do not include region, then you must create your changefeed with the option. |
topic\_name | (Optional) The topic name to which messages will be sent. See the following section on Topic Naming for detail on how topics are created. |
AUTH | The authentication parameter can define either specified (default) or implicit authentication. To use specified authentication, pass your Service Account credentials with the URI. To use implicit authentication, configure these credentials via an environment variable. Refer to the page for examples of each of these. |
CREDENTIALS | (Required with AUTH=specified) The base64-encoded credentials of your Google Service Account. |
ASSUME\_ROLE | The service account of the role to assume. Use in combination with AUTH=implicit or specified. Refer to the page for an example on setting up assume role authentication. |
CREATE CHANGEFEED page provides a list of all the available .
When using Pub/Sub as your downstream sink, consider the following:
- Pub/Sub sinks support
JSONmessage format. You can use the option in combination with for CSV-formatted messages. - Use the option for multi-region Pub/Sub. Google Cloud’s multi-region Pub/Sub will have lower latency when emitting from multiple regions, but Google Cloud Pub/Sub does not support message ordering for multi-region topics.
- Changefeeds connecting to a Pub/Sub sink do not support the
topic_prefixoption.
- To create topics on changefeed creation, you must use the Pub/Sub Editor role, which contains the permissions to create a topic.
- If the topic the changefeed is writing to already exists, then you can use the more limited Pub/Sub Publisher role, which can only write to existing topics.
You can use Google’s Pub/Sub emulator, which allows you to run Pub/Sub locally for testing. CockroachDB uses the Google Cloud SDK, which means that you can follow Google’s instructions for Setting environment variables to run the Pub/Sub emulator.
Pub/Sub topic naming
When running aCREATE CHANGEFEED statement to a Pub/Sub sink, consider the following regarding topic names:
- Changefeeds will try to create a topic automatically. When you do not specify the topic in the URI with the parameter, the changefeed will use the table name to create the topic name.
- If the topic already exists in your Pub/Sub sink, the changefeed will write to it.
- Changefeeds watching multiple tables will write to multiple topics corresponding to those table names.
- The option will create a topic using the fully qualified table name for each table the changefeed is watching.
- The output from
CREATE CHANGEFEEDwill display the job ID as well as the topic name(s) to which the changefeed will emit.
CREATE CHANGEFEED page.
Pub/Sub sink configuration
You can configure flushing, retry, and concurrency behavior of changefeeds running to a Pub/Sub sink with the following:- Set the to configure the number of concurrent workers used by changefeeds in the cluster when sending requests to a Pub/Sub sink. When you set
changefeed.sink_io_workers, it will not affect running changefeeds; , setchangefeed.sink_io_workers, and then . Note that this cluster setting will also affect changefeeds running to webhook sinks and Kafka. - Set the
pubsub_sink_configoption to configure the changefeed flushing and retry behavior to your webhook sink. For details on thepubsub_sink_configoption’s configurable fields, refer to the following table and examples.
| Field | Type | Description | Default |
|---|---|---|---|
Flush.Messages | The batch is flushed and its messages are sent when it contains this many messages. | 0 | |
Flush.Bytes | The batch is flushed when the total byte sizes of all its messages reaches this threshold. | 0 | |
Flush.Frequency | When this amount of time has passed since the first received message in the batch without it flushing, it should be flushed. | "0s" | |
Retry.Max | The maximum number of attempted batch emit retries after sending a message batch in a request fails. Specify either an integer greater than zero or the string inf to retry indefinitely. This only affects batch emit retries, not other causes of . Note that setting this field will not prevent the whole changefeed job from retrying indefinitely. | 3 | |
Retry.Backoff | How long the sink waits before retrying after the first failure. The backoff will double until it reaches the maximum retry time of 30 seconds. For example, if Retry.Max = 4 and Retry.Backoff = 10s, then the sink will try at most 4 retries, with 10s, 20s, 30s, and 30s backoff times. | "500ms" |
Setting either
Messages or Bytes with a non-zero value without setting Frequency will cause the sink to assume Frequency has an infinity value. If either Messages or Bytes have a non-zero value, then a non-zero value for Frequency must be provided. This configuration is invalid and will cause an error, since the messages could sit in a batch indefinitely if the other conditions do not trigger.Flush fields for batching:
-
When all batching parameters are zero (
"Messages","Bytes", and"Frequency") the sink will interpret this configuration as “send batch every time a message is available.” This would be the same as not providing any configuration at all: -
If one or more fields are set as non-zero values, any fields with a zero value the sink will interpret as infinity. For example, in the following configuration, the sink will send a batch whenever the size reaches 100 messages, or, when 5 seconds has passed since the batch was populated with its first message.
Bytesis unset, so the batch size is unlimited. No flush will be triggered due to batch size:
Pub/Sub sink messages
Thechangefeed.new_pubsub_sink_enabled cluster setting is enabled by default, which provides improved changefeed throughput peformance. With changefeed.new_pubsub_sink_enabled enabled, the changefeed JSON-encoded message format have top-level fields that are capitalized:
By default in v23.2, the capitalization of top-level fields in the message has changed. Before upgrading to CockroachDB v23.2 and later, you may need to reconfigure downstream systems to parse the new message format.
changefeed.new_pubsub_sink_enabled set to false, changefeeds emit JSON messages with the top-level fields all lowercase:
changefeed.new_pubsub_sink_enabled is set to false, changefeeds will not benefit from the improved throughput performance that this setting enables.
The following shows the default JSON messages for a changefeed emitting to Pub/Sub. These changefeed messages were emitted as part of the example:
Cloud storage sink
Use a cloud storage sink to deliver changefeed data to OLAP or big data systems without requiring transport via Kafka. Some considerations when using cloud storage sinks:- Cloud storage sinks work with
JSONand emit newline-delimitedJSONfiles. You can use the option in combination with for CSV-formatted messages. - Cloud storage sinks can be configured to store emitted changefeed messages in one or more subdirectories organized by date. See file partitioning and the examples.
- The supported cloud schemes are:
s3,gs,azure,http, andhttps. - Both
http://andhttps://are cloud storage sinks, not webhook sinks. It is necessary to prefix the scheme withwebhook-for webhook sinks.
specified or implicit authentication. CockroachDB also supports assume role authentication for Amazon S3 and Google Cloud Storage, which allows you to limit the control specific users have over your storage buckets. For detail and instructions on authenticating to cloud storage sinks, see .
Examples of supported cloud storage sink URIs:
Amazon S3
Azure Blob Storage
Google Cloud Storage
HTTP
Cloud storage parameters
The following table lists the available parameters for cloud storage sink URIs:| URI Parameter | Storage | Description |
|---|---|---|
AWS\_ACCESS\_KEY\_ID | AWS | The access key ID to your AWS account. |
AWS\_SECRET\_ACCESS\_KEY | AWS | The secret access key to your AWS account. |
ASSUME\_ROLE | AWS S3, GCS | The ARN (AWS) or service account (GCS) of the role to assume. Use in combination with AUTH=implicit or specified. AWS S3 only: Use external\_id with ASSUME\_ROLE to specify a third-party assigned external ID as part of the role. Refer to for setup details. |
AUTH | AWS S3, Azure Blob Storage, GCS | The authentication parameter can define either specified (default) or implicit authentication. To use specified authentication, pass your account credentials with the URI. To use implicit authentication, configure these credentials via an environment variable. See for examples of each of these. |
AZURE\_ACCOUNT\_NAME | Azure Blob Storage | The name of your Azure account. |
AZURE\_ACCOUNT\_KEY | Azure Blob Storage | The URL-encoded account key for your Azure account. |
AZURE\_CLIENT\_ID | Azure Blob Storage | Application (client) ID for your App Registration. |
AZURE\_CLIENT\_SECRET | Azure Blob Storage | Client credentials secret generated for your App Registration. |
AZURE\_ENVIRONMENT | Azure Blob Storage | The Azure environment that the storage account belongs to. The accepted values are: AZURECHINACLOUD, AZUREGERMANCLOUD, AZUREPUBLICCLOUD, and AZUREUSGOVERNMENTCLOUD. These are cloud environments that meet security, compliance, and data privacy requirements for the respective instance of Azure cloud. If the parameter is not specified, it will default to AZUREPUBLICCLOUD. |
AZURE\_TENANT\_ID | Azure Blob Storage | Directory (tenant) ID for your App Registration. |
CREDENTIALS | GCS | (Required with AUTH=specified) The base64-encoded credentials of your Google Service Account credentials. |
file\_size | All | The file will be flushed (i.e., written to the sink) when it exceeds the specified file size. This can be used with the , which flushes on a specified cadence. Default:16MB |
partition_format | All | Specify how changefeed are partitioned in cloud storage sinks. Use partition_format with the following values:
CREATE CHANGEFEED FOR TABLE users INTO 'gs://...?AUTH...&partition_format=hourly' Default: daily |
S3\_STORAGE\_CLASS | AWS S3 | Specify the S3 storage class for files created by the changefeed. See for the available classes and an example. Default:STANDARD |
topic\_prefix | All | Adds a prefix to all topic names. For example, CREATE CHANGEFEED FOR TABLE foo INTO 's3://...?topic\_prefix=bar\_' would emit rows under the topic bar\_foo instead of foo. |
CREATE CHANGEFEED page provides a list of all the available .
provides more detail on authentication to cloud storage sinks.
Cloud storage sink messages
The following shows the default JSON messages for a changefeed emitting to a cloud storage sink:Webhook sink
Use a webhook sink to deliver changefeed messages to an arbitrary HTTP endpoint. Example of a webhook sink URL:| URI Parameter | Description |
|---|---|
ca\_cert | The base64-encoded ca\_cert file. Specify ca\_cert for a webhook sink. Note: To encode your ca.cert, run base64 -w 0 ca.cert. |
client\_cert | The base64-encoded Privacy Enhanced Mail (PEM) certificate. This is used with client\_key. |
client\_key | The base64-encoded private key for the PEM certificate. This is used with client\_cert. Note: Client keys are often encrypted. You will receive an error if you pass an encrypted client key in your changefeed statement. To decrypt the client key, run: openssl rsa -in key.pem -out key.decrypt.pem -passin pass:{PASSWORD}. Once decrypted, be sure to update your changefeed statement to use the new key.decrypt.pem file instead. |
insecure\_tls\_skip\_verify | If true, disable client-side validation of responses. Note that a CA certificate is still required; this parameter means that the client will not verify the certificate. Warning: Use this query parameter with caution, as it creates MITM vulnerabilities unless combined with another method of authentication. Default:false |
CREATE CHANGEFEED page provides a list of all the available .
The following are considerations when using the webhook sink:
- Only supports HTTPS. Use the parameter when testing to disable certificate verification; however, this still requires HTTPS and certificates.
- Supports JSON output format. You can use the option in combination with for CSV-formatted messages.
Webhook sink configuration
You can configure flushing, retry, and concurrency behavior of changefeeds running to a webhook sink with the following:- Set the to configure the number of concurrent workers used by changefeeds in the cluster when sending requests to a webhook sink. When you set
changefeed.sink_io_workers, it will not affect running changefeeds; , setchangefeed.sink_io_workers, and then . Note that this cluster setting will also affect changefeeds running to Google Cloud Pub/Sub sinks and Kafka. - Set the
webhook_sink_configoption to configure the changefeed flushing and retry behavior to your webhook sink. For details on thewebhook_sink_configoption’s configurable fields, refer to the following table and examples.
| Field | Type | Description | Default |
|---|---|---|---|
Flush.Messages | The batch is flushed and its messages are sent when it contains this many messages. | 0 | |
Flush.Bytes | The batch is flushed when the total byte sizes of all its messages reaches this threshold. | 0 | |
Flush.Frequency | When this amount of time has passed since the first received message in the batch without it flushing, it should be flushed. | "0s" | |
Retry.Max | The maximum number of attempted HTTP retries after sending a message batch in an HTTP request fails. Specify either an integer greater than zero or the string inf to retry indefinitely. This only affects HTTP retries, not other causes of . Note that setting this field will not prevent the changefeed from retrying indefinitely. | 3 | |
Retry.Backoff | How long the sink waits before retrying after the first failure. The backoff will double until it reaches the maximum retry time of 30 seconds. For example, if Retry.Max = 4 and Retry.Backoff = 10s, then the sink will try at most 4 retries, with 10s, 20s, 30s, and 30s backoff times. | "500ms" |
Messages or Bytes with a non-zero value without setting Frequency will cause the sink to assume Frequency has an infinity value. If either Messages or Bytes have a non-zero value, then a non-zero value for Frequency must be provided. This configuration is invalid and will cause an error, since the messages could sit in a batch indefinitely if the other conditions do not trigger.
Some complexities to consider when setting Flush fields for batching:
-
When all batching parameters are zero (
"Messages","Bytes", and"Frequency") the sink will interpret this configuration as “send batch every time a message is available.” This would be the same as not providing any configuration at all: -
If one or more fields are set as non-zero values, any fields with a zero value the sink will interpret as infinity. For example, in the following configuration, the sink will send a batch whenever the size reaches 100 messages, or, when 5 seconds has passed since the batch was populated with its first message.
Bytesis unset, so the batch size is unlimited. No flush will be triggered due to batch size:
Webhook sink messages
The following shows the default JSON messages for a changefeed emitting to a webhook sink. These changefeed messages were emitted as part of the example:Azure Event Hubs
Changefeeds can deliver messages to an Azure Event Hub, which is compatible with Apache Kafka. An Azure Event Hubs sink URI:kafka:// scheme in the URI:
shared_access_key and shared_access_key_name are the required parameters for an Azure Event Hubs connection URI.
| URI Parameter | Description |
|---|---|
{event\_hubs\_namespace} | The Event Hub namespace. |
shared\_access\_key\_name | The name of the shared access policy created for the namespace. |
shared\_access\_key | The key for the shared access policy. Note: You must URL encode the shared access key before passing it in the connection string. |
topic_name and topic_prefix. Azure Event Hubs also supports the standard Kafka and the Kafka sink configuration option.
For an Azure Event Hub setup example, refer to the page.
The following parameters are also needed, but are set by default in CockroachDB:
tls_enabled=truesasl_enabled=truesasl_handshake=truesasl_mechanism=PLAIN
Apache Pulsar
This feature is in and subject to change. To share feedback and/or issues, contact Support.
:6650. For more detail on configuration, refer to the Apache Pulsar documentation.
Changefeeds emitting to an Apache Pulsar sink support json and csv .
Changefeeds emitting to an Apache Pulsar sink do not support:
- Any batching configuration

